#!/usr/bin/env python
'''
This file contains Python command example for the Port module.
Python commands syntax is very similar to the Switch SDK APIs. 
You can learn more about each command and its parameters by reading the SwitchX API Reference Manual.

need to add description 
'''
import os
import sys
import errno, sys ,struct ,socket
import colorsys
import random
import traceback
import os
import inspect

from python_sdk_api.sx_api import *

from test_infra_common import *

def main():
    print "[+] opening sdk"
    rc, handle = sx_api_open(None)
    print ("sx_api_open handle:0x%x , rc %d " % ( handle, rc) )
    if (rc != SX_STATUS_SUCCESS):
        print "Failed to open api handle.\nPlease check that SDK is running."
        sys.exit(errno.EACCES)
    
    port_list = mapPortAndInterfaces(handle)
    PORT1 = port_list[0]
    
    port_ptp_params = sx_port_ptp_params_t()
    port_ptp_params.low_speed_role = SX_PORT_PTP_LOW_SPEED_RX_ROLE_PRIMARY
    port_ptp_params.cmd = SX_PORT_PTP_ROLE_CMD_ENABLE
    
    ptp_shaper_params = sx_cos_ets_ptp_shaper_params_t()
    ptp_shaper_params.time_exp = 4
    ptp_shaper_params.time_mantissa = 7
    ptp_shaper_params.shaper_inc = 6
    ptp_shaper_params.shaper_bs = 6
    ptp_shaper_params.port_to_shaper_credits = 1

    ptp_shaper_params_p = new_sx_cos_ets_ptp_shaper_params_t_p()
    port_ptp_params_p = new_sx_port_ptp_params_t_p()
            
    print "setting ptp shaper params"
    rc = sx_api_cos_ets_ptp_shaper_param_set(handle, SX_ACCESS_CMD_SET, SX_COS_ETS_PTP_PORT_SPEED_100G, ptp_shaper_params)
    assert rc == SX_STATUS_SUCCESS, "failed to set ptp shaper params, rc = %d" % rc
        
    print "validating ptp shaper params"
    rc = sx_api_cos_ets_ptp_shaper_param_get(handle, SX_ACCESS_CMD_GET, SX_COS_ETS_PTP_PORT_SPEED_100G, ptp_shaper_params_p)
    assert rc == SX_STATUS_SUCCESS, "failed to get ptp shaper params for speed %d" % SX_COS_ETS_PTP_PORT_SPEED_100G
    
    ptp_shaper_params_get_val = sx_cos_ets_ptp_shaper_params_t_p_value(ptp_shaper_params_p)
    
    assert ptp_shaper_params_get_val.time_exp == ptp_shaper_params.time_exp ,"time_exp got: %d, set: %d" % (ptp_shaper_params_get_val.time_exp, ptp_shaper_params.time_exp)
    assert ptp_shaper_params_get_val.time_mantissa == ptp_shaper_params.time_mantissa, "time_mantissa got: %d, set: %d" % (ptp_shaper_params_get_val.time_mantissa, ptp_shaper_params.time_mantissa)
    assert ptp_shaper_params_get_val.shaper_inc == ptp_shaper_params.shaper_inc, "shaper_inc got: %d, set: %d" % (ptp_shaper_params_get_val.shaper_inc, ptp_shaper_params.shaper_inc)
    assert ptp_shaper_params_get_val.shaper_bs == ptp_shaper_params.shaper_bs, "shaper_bs got: %d, set: %d" % (ptp_shaper_params_get_val.shaper_bs, ptp_shaper_params.shaper_bs)
    assert ptp_shaper_params_get_val.port_to_shaper_credits == ptp_shaper_params.port_to_shaper_credits, "port_to_shaper_credits got: %d, set: %d" % (ptp_shaper_params_get_val.port_to_shaper_credits, ptp_shaper_params.port_to_shaper_credits)

    print "deleting ptp shaper params"
    rc = sx_api_cos_ets_ptp_shaper_param_set(handle, SX_ACCESS_CMD_DELETE, SX_COS_ETS_PTP_PORT_SPEED_100G, ptp_shaper_params)
    assert rc == SX_STATUS_SUCCESS, "failed to set ptp shaper params, rc = %d" % rc
    
    print "setting ptp port params"
    rc = sx_api_port_ptp_params_set(handle, SX_ACCESS_CMD_EDIT, PORT1, port_ptp_params)
    assert rc == SX_STATUS_SUCCESS, "failed to set ptp port params for port %d and role %d" % (PORT1, port_ptp_params.low_speed_role)

    print "getting ptp port params"
    rc = sx_api_port_ptp_params_get(handle, SX_ACCESS_CMD_GET, PORT1, port_ptp_params_p)
    assert rc == SX_STATUS_SUCCESS, "failed to get ptp port params for port %d" % PORT1

if __name__ == "__main__":
    main()
          