#!/usr/bin/env python
'''
This file contains Python command example for the ALL PORT COUNTER READ module.
Python commands syntax is very similar to the Switch SDK APIs. 
You can learn more about each command and its parameters by reading the SwitchX API Reference Manual.

The example below demonstrates the configuration of different port attributes.
'''
import sys, errno
import os.path
from python_sdk_api.sx_api import *
            
print "[+] opening sdk"
rc, handle = sx_api_open(None)
print ("sx_api_open handle:0x%x , rc %d " % ( handle, rc) )
if (rc != SX_STATUS_SUCCESS):
    print "Failed to open api handle.\nPlease check that SDK is running."
    sys.exit(errno.EACCES)
    
if len(sys.argv) >= 2:
    dump_file_path = str(sys.argv[1])
else:
    dump_file_path = "/tmp/sdkdump"
    print ("No dump file path was entered as a parameter.\nWill use the default: %s path." % dump_file_path )

rc = sx_api_dbg_generate_dump(handle, dump_file_path)

print ("sx_api_dbg_generate_dump, rc %d" % rc )

sx_api_close(handle)
