#!/usr/bin/env python

import sys
import time
import os
from python_sdk_api.sxd_api import *

print "[+] PMCR register access test start"
print "[+] initializing register access"
sxd_access_reg_init(0, None, 4)

pmcr = ku_pmcr_reg()

meta = sxd_reg_meta_t()
meta.dev_id = 1
meta.swid = 0

meta.access_cmd = SXD_ACCESS_CMD_GET

pmcr.local_port = 1

print "[+] Get PMCR"
sxd_access_reg_pmcr(pmcr, meta, 1, None, None)

print "[+] local port: ", pmcr.local_port

print "[+] Get PMCR content"
print "===================="
print "[+] CDR override control: ", pmcr.cdr_override_cntl
print "[+] CDR override value: ", pmcr.cdr_override_value
print "[+] Rx AMP control: ", pmcr.rx_amp_override_cntl
print "[+] Rx AMP override value: ", pmcr.rx_amp_override_value
print "[+] Rx EMP control: ", pmcr.rx_emp_override_cntl
print "[+] Rx EMP override value: ", pmcr.rx_emp_override_value
print "[+] Tx EQU control: ", pmcr.tx_equ_override_cntl
print "[+] Tx EQU override value: ", pmcr.tx_equ_override_value

meta.access_cmd = SXD_ACCESS_CMD_SET

pmcr.cdr_override_cntl = 2
pmcr.cdr_override_value = 3
pmcr.rx_amp_override_cntl = 0
pmcr.rx_amp_override_cntl = 0
pmcr.rx_emp_override_cntl = 1
pmcr.rx_emp_override_value = 0
pmcr.tx_equ_override_cntl = 2
pmcr.tx_equ_override_value = 1

print "[+] Set PMCR content"
print "===================="
print "[+] CDR override control: ", pmcr.cdr_override_cntl
print "[+] CDR override value: ", pmcr.cdr_override_value
print "[+] Rx AMP control: ", pmcr.rx_amp_override_cntl
print "[+] Rx AMP override value: ", pmcr.rx_amp_override_value
print "[+] Rx EMP control: ", pmcr.rx_emp_override_cntl
print "[+] Rx EMP override value: ", pmcr.rx_emp_override_value
print "[+] Tx EQU control: ", pmcr.tx_equ_override_cntl
print "[+] Tx EQU override value: ", pmcr.tx_equ_override_value

print "[+] Set PMCR"
sxd_access_reg_pmcr(pmcr, meta, 1, None, None)
  
meta.access_cmd = SXD_ACCESS_CMD_GET

print "[+] Get PMCR"
sxd_access_reg_pmcr(pmcr, meta, 1, None, None)

print "[+] Get after Set PMCR content"
print "=============================="
print "[+] CDR override control: ", pmcr.cdr_override_cntl
print "[+] CDR override value: ", pmcr.cdr_override_value
print "[+] Rx AMP control: ", pmcr.rx_amp_override_cntl
print "[+] Rx AMP override value: ", pmcr.rx_amp_override_value
print "[+] Rx EMP control: ", pmcr.rx_emp_override_cntl
print "[+] Rx EMP override value: ", pmcr.rx_emp_override_value
print "[+] Tx EQU control: ", pmcr.tx_equ_override_cntl
print "[+] Tx EQU override value: ", pmcr.tx_equ_override_value

print "[+] PMCR register access test end"
